'====================================================================
#include "windows.bi"
#include "counter.bas"
'====================================================================
'' Counter.bas is available here:
''
'' http://www.freebasic.net/forum/viewtopic.php?t=4221
'====================================================================

sleep 3000

counter_begin( 1000, HIGH_PRIORITY_CLASS )
  asm xor edx, edx
  asm mov eax, 1
  asm div ecx
counter_end
print counter_cycles

counter_begin( 1000, HIGH_PRIORITY_CLASS )
  asm rcr eax, 31
  asm rcl eax, 31
counter_end
print counter_cycles

counter_begin( 1000, HIGH_PRIORITY_CLASS )
  asm pushad
  asm popad
counter_end
print counter_cycles

dim as integer seed = 123, _base = 100

counter_begin( 1000, HIGH_PRIORITY_CLASS )

  asm
    mov eax, seed
    test eax, 0x80000000
    jz  L1
    add eax, 0x7fffffff
  L1:
    xor edx, edx
    mov ecx, 127773
    div ecx
    mov ecx, eax
    mov eax, 16807
    mul edx
    mov edx, ecx
    mov ecx, eax
    mov eax, 2836
    mul edx
    sub ecx, eax
    xor edx, edx
    mov eax, ecx
    mov seed, ecx
    div _base
    mov eax, edx
  end asm

counter_end
print counter_cycles

sleep
